import { MigrationInterface, QueryRunner, Table, TableColumn } from "typeorm";

export class Invite1724579024939 implements MigrationInterface {
  name = "Invite1724579024939";

  public async up(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.createTable(
      new Table({
        name: "invite",
        columns: [
          { name: "mail", type: "varchar", length: "255", isPrimary: true, isNullable: false },
          { name: "token", type: "varchar", length: "255", isNullable: false },
          { name: "username", type: "varchar", length: "255", isNullable: false },
          { name: "firstname", type: "varchar", length: "255", isNullable: false },
          { name: "lastname", type: "varchar", length: "255", isNullable: false },
          { name: "secret", type: "varchar", length: "255", isNullable: false },
        ],
      }),
      true
    );

    await queryRunner.addColumns("user", [
      new TableColumn({
        name: "firstname",
        type: "varchar",
        length: "255",
        isNullable: false,
      }),
      new TableColumn({
        name: "lastname",
        type: "varchar",
        length: "255",
        isNullable: false,
      }),
    ]);
  }

  public async down(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.dropColumns("user", ["lastname", "firstname"]);
    await queryRunner.dropTable("invite");
  }
}
